// 
// FLTK window definitions
//

#ifndef FLVALUE_H
#define FLVALUE_H

#include <string.h>
#include <stdio.h>

//
// Draws a single string, int, or double value, with an associated label
// Can change formatting and type at any time; value() fn is overloaded
// value(char *) acts as formatter for numeric values
// If formatter is changed, the numeric value must be resent
//

class Fl_Value : public Fl_Widget 
{

public:
  Fl_Value(int x, int y, int w, int h, const char *l=0, const char *val = "");
  void val(char *v) { if (v) { strcpy(str,v); strcpy(buf,v); } redraw(); }
  void val(int x) { sprintf(buf, str, x); redraw(); }
  void val(double x) { sprintf(buf, str, x); redraw(); }
  void setcolor(Fl_Color x) { c = x; }

private:
  void draw()
  { 
    fl_color(color());
    fl_rectf(x(),y(),w(),h());  // erase background
    fl_font(FL_HELVETICA_BOLD, labelsize());
    fl_color(c);
    fl_draw(buf, x(), y()+ h()/2 + fl_height()/2 - fl_descent() );
  }
  Fl_Color c;
  char str[100];
  char buf[100];
};


#endif
