//
// timer.c
// 
// OS-independent timing fns
//
//
// Copyright 2000 by Videre Design 
//


//
// UNIX timing fns
//

#ifndef WIN32
#include <sys/time.h>
#include <sys/resource.h>

void
ms_sleep(int milliseconds)
{
  struct timeval delay;
  fd_set readfds, writefds, execfds;
  delay.tv_sec = milliseconds / 1000;
  delay.tv_usec = (milliseconds % 1000) * 1000;
  select (0, &readfds, &writefds, &execfds, &delay);
}


int
ms_time(void)
{
  struct timeval t;
  gettimeofday(&t,0L);
  return(t.tv_sec*1000 + t.tv_usec/1000);
}

#endif

//
// MSW timing fns
//

#ifdef WIN32

#include <windows.h>
#include <mmsystem.h>

#define CYCLE_TIME 100

long
ms_time(void)
{
  return (int)timeGetTime();
}


void
ms_sleep(int ms)
{
  Sleep(ms);
}

#endif


